#include <dos.h>
#include <stdlib.h>
#include <conio.h>
#include "..\source\vmode.c"
#include "..\source\sprite.cpp"
#include "..\source\csprite.cpp"

unsigned char BallBitmap[] = {
     0,  0,  0, 14, 14, 14, 14,  0,  0,  0,
     0, 14, 14, 14, 14, 14, 14, 14, 14,  0,
     0, 14, 14,  0,  0, 14, 14, 14, 14,  0,
    14, 14,  0,  0, 14, 14, 14, 14, 14, 14,
    14, 14,  0, 14, 14, 14, 14, 14, 14, 14,
    14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
    14, 14, 14, 14, 14, 14, 14, 14, 14, 14,
     0, 14, 14, 14, 14, 14, 14, 14, 14,  0,
     0, 14, 14, 14, 14, 14, 14, 14, 14,  0,
     0,  0,  0, 14, 14, 14, 14,  0,  0,  0
};

void Delay(int clicks);

int main(void)
{
    int i, y;
    int x_dir = 1, y_dir = -1;
    ClipSprite Ball(10, 10, 1, true, false);
    if (!Ball.InitOk()) return 1;

    SetVideoMode(VGA256);
    // FillScreen(2);

    for (i = 0; i < 150; i++) {
        y = rand() % ScreenHeight;
        SetPixel(rand() % ScreenWidth, y, rand() % ScreenColors);
    }

    Ball.SetX(100);
    Ball.SetY(100);
    Ball.SetIndexedImage(BallBitmap);
    Ball.Show();

    while (_kbhit()) _getch();
    while (!_kbhit());
    while (_kbhit()) _getch();
    while (!_kbhit()) {
        if (Ball.GetX() < -10 || Ball.GetX() > 320)
            x_dir = -x_dir;
        if (Ball.GetY() < -10 || Ball.GetY() > 200)
            y_dir = -y_dir;
        Ball.MoveRelative(x_dir, y_dir);
        Delay(1);
    }
    while (_kbhit()) _getch();

    SetVideoMode(TEXT_MODE);
    return 0;
}

void Delay(int clicks)
{
// this function uses the internal time keeper timer i.e. the one that goes
// at 18.2 clicks/sec to to a time delay.  You can find a 32 bit value of
// this timer at 0000:046Ch

unsigned int far *clock = (unsigned int far *)0x0000046CL;

unsigned int now;

// get current time

now = *clock;

// wait till time has gone past current time plus the amount we eanted to
// wait.  Note each click is approx. 55 milliseconds.

while(abs(*clock - now) < clicks){}

} // end Delay

