/* LINES.C -- Sets random pixels.
 *
 * Compile and link with the GAMELIB.LIB file.
 *
 * by Gary Neal, Jr.
 */

#include <stdlib.h>               /* Needed for the rand() function */
#include <conio.h>                /* Console specific input/output */
#include "..\include\vmode.h"     /* Video mode functions */
#include "..\include\fgraph.h"    /* Floating point graphics functions */

int main(void)
{
    while (_kbhit()) _getch();    /* Clear the keyboard */

    SetVideoMode(VGA256);         /* Switch to VGA mode 13H */

    while (!_kbhit())
        Line(rand()%ScreenWidth, rand()%ScreenHeight,
             rand()%ScreenWidth, rand()%ScreenHeight,
             rand()%ScreenColors);

    while (_kbhit()) _getch();    /* Clear the keyboard */

    SetVideoMode(TEXT_MODE);      /* Return to text mode */

    return 0;                     /* Return with success */
}
